# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ResourceType(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'created_by': 'str',
        'updated_by': 'str',
        'created_at': 'datetime',
        'updated_at': 'datetime',
        'display_name': 'str',
        'description': 'str',
        'schema': 'PageResourceTypeSchema',
        'provider_id': 'str',
        'org_id': 'str',
        'project_id': 'str',
        'account_type': 'str',
        'composable': 'bool'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'created_by': 'createdBy',
        'updated_by': 'updatedBy',
        'created_at': 'createdAt',
        'updated_at': 'updatedAt',
        'display_name': 'displayName',
        'description': 'description',
        'schema': 'schema',
        'provider_id': 'providerId',
        'org_id': 'orgId',
        'project_id': 'projectId',
        'account_type': 'accountType',
        'composable': 'composable'
    }

    def __init__(self, id=None, name=None, created_by=None, updated_by=None, created_at=None, updated_at=None, display_name=None, description=None, schema=None, provider_id=None, org_id=None, project_id=None, account_type=None, composable=None):  # noqa: E501
        """ResourceType - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._created_by = None
        self._updated_by = None
        self._created_at = None
        self._updated_at = None
        self._display_name = None
        self._description = None
        self._schema = None
        self._provider_id = None
        self._org_id = None
        self._project_id = None
        self._account_type = None
        self._composable = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if created_by is not None:
            self.created_by = created_by
        if updated_by is not None:
            self.updated_by = updated_by
        if created_at is not None:
            self.created_at = created_at
        if updated_at is not None:
            self.updated_at = updated_at
        if display_name is not None:
            self.display_name = display_name
        if description is not None:
            self.description = description
        if schema is not None:
            self.schema = schema
        if provider_id is not None:
            self.provider_id = provider_id
        if org_id is not None:
            self.org_id = org_id
        if project_id is not None:
            self.project_id = project_id
        if account_type is not None:
            self.account_type = account_type
        if composable is not None:
            self.composable = composable

    @property
    def id(self):
        """Gets the id of this ResourceType.  # noqa: E501

        Resource type id  # noqa: E501

        :return: The id of this ResourceType.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ResourceType.

        Resource type id  # noqa: E501

        :param id: The id of this ResourceType.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this ResourceType.  # noqa: E501

        Resource type name  # noqa: E501

        :return: The name of this ResourceType.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ResourceType.

        Resource type name  # noqa: E501

        :param name: The name of this ResourceType.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def created_by(self):
        """Gets the created_by of this ResourceType.  # noqa: E501

        Name of the user who created the resource type.  # noqa: E501

        :return: The created_by of this ResourceType.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this ResourceType.

        Name of the user who created the resource type.  # noqa: E501

        :param created_by: The created_by of this ResourceType.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def updated_by(self):
        """Gets the updated_by of this ResourceType.  # noqa: E501

        Name of the user who updated the resource type.  # noqa: E501

        :return: The updated_by of this ResourceType.  # noqa: E501
        :rtype: str
        """
        return self._updated_by

    @updated_by.setter
    def updated_by(self, updated_by):
        """Sets the updated_by of this ResourceType.

        Name of the user who updated the resource type.  # noqa: E501

        :param updated_by: The updated_by of this ResourceType.  # noqa: E501
        :type: str
        """

        self._updated_by = updated_by

    @property
    def created_at(self):
        """Gets the created_at of this ResourceType.  # noqa: E501

        Time at which the resource type was created.  # noqa: E501

        :return: The created_at of this ResourceType.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this ResourceType.

        Time at which the resource type was created.  # noqa: E501

        :param created_at: The created_at of this ResourceType.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this ResourceType.  # noqa: E501

        Time at which the resource type was updated.  # noqa: E501

        :return: The updated_at of this ResourceType.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this ResourceType.

        Time at which the resource type was updated.  # noqa: E501

        :param updated_at: The updated_at of this ResourceType.  # noqa: E501
        :type: datetime
        """

        self._updated_at = updated_at

    @property
    def display_name(self):
        """Gets the display_name of this ResourceType.  # noqa: E501

        Resource display name  # noqa: E501

        :return: The display_name of this ResourceType.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this ResourceType.

        Resource display name  # noqa: E501

        :param display_name: The display_name of this ResourceType.  # noqa: E501
        :type: str
        """

        self._display_name = display_name

    @property
    def description(self):
        """Gets the description of this ResourceType.  # noqa: E501

        Resource type description  # noqa: E501

        :return: The description of this ResourceType.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ResourceType.

        Resource type description  # noqa: E501

        :param description: The description of this ResourceType.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def schema(self):
        """Gets the schema of this ResourceType.  # noqa: E501


        :return: The schema of this ResourceType.  # noqa: E501
        :rtype: PageResourceTypeSchema
        """
        return self._schema

    @schema.setter
    def schema(self, schema):
        """Sets the schema of this ResourceType.


        :param schema: The schema of this ResourceType.  # noqa: E501
        :type: PageResourceTypeSchema
        """

        self._schema = schema

    @property
    def provider_id(self):
        """Gets the provider_id of this ResourceType.  # noqa: E501

        Provider Id  # noqa: E501

        :return: The provider_id of this ResourceType.  # noqa: E501
        :rtype: str
        """
        return self._provider_id

    @provider_id.setter
    def provider_id(self, provider_id):
        """Sets the provider_id of this ResourceType.

        Provider Id  # noqa: E501

        :param provider_id: The provider_id of this ResourceType.  # noqa: E501
        :type: str
        """

        self._provider_id = provider_id

    @property
    def org_id(self):
        """Gets the org_id of this ResourceType.  # noqa: E501

        Org ID where resource type belongs  # noqa: E501

        :return: The org_id of this ResourceType.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this ResourceType.

        Org ID where resource type belongs  # noqa: E501

        :param org_id: The org_id of this ResourceType.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def project_id(self):
        """Gets the project_id of this ResourceType.  # noqa: E501

        Project ID where resource type belongs  # noqa: E501

        :return: The project_id of this ResourceType.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this ResourceType.

        Project ID where resource type belongs  # noqa: E501

        :param project_id: The project_id of this ResourceType.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def account_type(self):
        """Gets the account_type of this ResourceType.  # noqa: E501

        Optional. Account type to which the resource type belongs to. Example: AWS, Azure etc  # noqa: E501

        :return: The account_type of this ResourceType.  # noqa: E501
        :rtype: str
        """
        return self._account_type

    @account_type.setter
    def account_type(self, account_type):
        """Sets the account_type of this ResourceType.

        Optional. Account type to which the resource type belongs to. Example: AWS, Azure etc  # noqa: E501

        :param account_type: The account_type of this ResourceType.  # noqa: E501
        :type: str
        """

        self._account_type = account_type

    @property
    def composable(self):
        """Gets the composable of this ResourceType.  # noqa: E501

        Composable with other types or not  # noqa: E501

        :return: The composable of this ResourceType.  # noqa: E501
        :rtype: bool
        """
        return self._composable

    @composable.setter
    def composable(self, composable):
        """Sets the composable of this ResourceType.

        Composable with other types or not  # noqa: E501

        :param composable: The composable of this ResourceType.  # noqa: E501
        :type: bool
        """

        self._composable = composable

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ResourceType, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ResourceType):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
